;;; Manipulating the iTunes plist in Scheme

(use eggdoc)
(use doc-parser)

(define url "http://3e8.org/zb/cocoa/")

(define doc
  `((eggdoc:begin
     (name "Manipulating the iTunes property list file in Scheme")
     (p "Jim Ursetto" (br)
        (url "http://ursetto.com" "Ursetto Consulting, Inc."))
     (download (div (url "http://3e8.org/zb/cocoa/itunes.scm" "Article source code") (br)
                    (url "http://3e8.org/zb/cocoa/itunes-plist.tgz" "Article tarball")))
                    
     ,@(parse-doc "itunes.scm")
     
)))


;; We're using the eggdoc template, but this isn't really an egg.
(define stylesheet
  `(
    (eggdoc-style2 . ,(lambda (tag)
                        `("<style type=\"text/css\">"
                          "pre { margin-left: 2em; padding-top: 0.5em; padding-bottom: 0.5em; padding-left: 0.5em; background: #eef; border: 1px solid #ccd; }"
                          "pre.repl { color: #141; background: #efe; border: 1px solid #cdc; }"
                          "div.subsection { border-top: 1px solid #ccc; margin-left: -0.7em; padding-left: 0.7em; padding-top: 0.5em; margin-top: 1.5em; }"
                          "div.section { margin-bottom: 3.5em; }"
                          "</style>")))
    (repl *macro* . ,(lambda (tag . contents)
                       `(pre (@ (class "repl")) ,contents)))

    (eggdoc:begin *macro* . ,(lambda (tag . contents)
                               (let ((name (cadr (assq 'name (cdar doc)))))
                                 `((eggdoc-doctype)
                                   (eggdoc-version)
                                   (html (head (title ,name)
                                               (eggdoc-style)
                                               (eggdoc-style2))
                                         (body
                                          (div (@ (id "header"))
                                               (h2 ,name))

                                          (div (@ (id "body"))
                                               ,contents)
                                          
                                          (div (@ (id "footer"))
                                               (hr)
                                               "version 0.1 11-feb-2006 author: j. ursetto"
                                               )))))))))  ;; nbsp so div block takes up space

(eggdoc->html doc (append stylesheet
                          (eggdoc:make-stylesheet doc)))
